<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingOsemembership extends JPlugin{

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'osemembership');
			$this->params = new JParameter($plugin->params);
		}
	}

	function onAcyDisplayFilters(&$type, $context = "massactions"){

		if($this->params->get('displayfilter_'.$context, true) == false) return;

		$db = JFactory::getDBO();
		$db->setQuery("SELECT * FROM `#__osemsc_acl` ORDER BY `ordering` ASC");
		$osemc = $db->loadObjectList('id');

		if(empty($osemc)) return;

		$onePlan = reset($osemc);
		$planVarName = isset($onePlan->name) ? 'name' : 'title';

		$firstGroup = new stdClass();
		$firstGroup->$planVarName = JText::_('ACY_ALL');
		$firstGroup->id = 0;
		array_unshift($osemc, $firstGroup);

		$type['osemembership'] = 'OSE Membership Control Manager';

		$osemcin = acymailing_get('type.operatorsin');
		$osemcin->js = 'onchange="countresults(__num__)"';

		$jsOnChange = "displayCondFilter('displayOSEMembershipPayments', 'toChangepayment__num__',__num__,'membership='+document.getElementById('filter__num__osemembershipgroup').value+'&value='+document.getElementById('filter__num__osemembershippayment').value); ";

		$return = '<div id="filter__num__osemembership">'.$osemcin->display("filter[__num__][osemembership][type]").' ';
		$return .= JHTML::_('select.genericlist', $osemc, "filter[__num__][osemembership][group]", 'class="inputbox" onchange="'.$jsOnChange.'countresults(__num__)" size="1"', 'id', $planVarName);
		$return .= ' <span id="toChangepayment__num__"><input onchange="countresults(__num__)" disabled="disabled" class="inputbox" type="text" name="filter[__num__][osemembership][payment]" style="width:200px" value="" id="filter__num__osemembershippayment"/></span>';
		$return .= '<br /><input type="text" onchange="countresults(__num__)" name="filter[__num__][osemembership][expiry_date_inf]" value="'.date('Y-m-d').'"/> < '.JText::_('EXPIRY_DATE').' < <input type="text" onchange="countresults(__num__)" name="filter[__num__][osemembership][expiry_date_sup]" value=""/>';
		$return .= '</div>';

		$db->setQuery('SELECT *, CONCAT(id,"-",type) AS idtype FROM `#__osemsc_fields` WHERE published = 1 AND type NOT LIKE "fileuploadfield" ORDER BY `ordering` ASC');
		$osefields = $db->loadObjectList('idtype');

		if(empty($osefields)) return $return;

		$type['osefields'] = 'OSE Membership Custom Fields';
		$operatorosefield = acymailing_get('type.operators');
		$operatorosefield->extra = 'onchange="countresults(__num__)"';


		$jsOnChange = "displayCondFilter('displayOSEMembersValues', 'toChange__num__',__num__,'field='+document.getElementById('filter__num__osefieldsfield').value+'&cond='+document.getElementById('filter__num__osefieldsoperator').value+'&value='+document.getElementById('filter__num__osefieldsvalue').value); ";

		$return .= '<div id="filter__num__osefields">'.JHTML::_('select.genericlist', $osefields, "filter[__num__][osefields][field]", 'class="inputbox" onchange="'.$jsOnChange.'countresults(__num__)" size="1"', 'idtype', 'name');
		$return .= ' '.$operatorosefield->display("filter[__num__][osefields][operator]").' <span id="toChange__num__"><input onchange="countresults(__num__)" class="inputbox" type="text" name="filter[__num__][osefields][value]" style="width:200px" value="" id="filter__num__osefieldsvalue"/></span></div>';

		return $return;
	}

	function onAcyProcessFilterCount_osemembership(&$query, $filter, $num){
		$this->onAcyProcessFilter_osemembership($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_osemembership(&$query, $filter, $num){
		$query->leftjoin['osemem'.$num] = $this->_makeLJ($query, $filter, $num);
		$suffix = $this->params->get('osesuffix', '_expired');

		$query->leftjoin['_exposemem'.$num] = $this->_makeLJ($query, $filter, $num, $suffix);

		if($filter['type'] == 'IN'){
			if(!empty($filter['payment'])){
				$query->join['osemem'.$num.'order'] = '#__osemsc_order AS osemem'.$num.'order ON sub.userid = osemem'.$num.'order.user_id';
				$query->join['osemem'.$num.'payment'] = '#__osemsc_order_item AS osemem'.$num.'payment ON osemem'.$num.'order.order_id = osemem'.$num.'payment.order_id';
				$query->where['osemem'.$num.'paymentwhere'] = 'osemem'.$num.'payment.params LIKE '.$query->db->quote('%"msc_option":"'.$filter['payment'].'"%');
			}
			$query->where[] = "sub.userid > 0 AND (".$suffix."osemem$num.`member_id` IS NOT NULL OR osemem$num.`member_id` IS NOT NULL)";
		}else{
			if(!empty($filter['payment'])){
				$query->leftjoin['osemem'.$num.'order'] = '#__osemsc_order AS osemem'.$num.'order ON sub.userid = osemem'.$num.'order.user_id';
				$query->leftjoin['osemem'.$num.'payment'] = '#__osemsc_order_item AS osemem'.$num.'payment ON osemem'.$num.'order.order_id = osemem'.$num.'payment.order_id';
				$query->where['osemem'.$num.'paymentwhere'] = 'osemem'.$num.'payment.params IS NULL OR osemem'.$num.'payment.params NOT LIKE '.$query->db->quote('%"msc_option":"'.$filter['payment'].'"%');
			}else{
				$query->where[] = $suffix."osemem$num.`member_id` IS NULL AND osemem$num.`member_id` IS NULL";
			}
		}
	}

	function _makeLJ(&$query, &$filter, &$num, $prefix = ''){
		$lj = "`#__osemsc_member$prefix` as ".$prefix."osemem$num ON ".$prefix."osemem$num.`member_id` = sub.`userid`";

		if(!empty($filter['group'])) $lj .= " AND ".$prefix."osemem$num.`msc_id` = ".intval($filter['group']);

		if(!empty($filter['expiry_date_inf'])){
			$filter['expiry_date_inf'] = acymailing_replaceDate($filter['expiry_date_inf']);
			if(is_numeric($filter['expiry_date_inf'])) $filter['expiry_date_inf'] = date('Y-m-d H:i', $filter['expiry_date_inf']);
			$lj .= " AND (".$prefix."osemem$num.`expired_date` > ".$query->db->Quote($filter['expiry_date_inf'])." OR ".$prefix."osemem$num.`expired_date` < '1970')";
		}

		if(!empty($filter['expiry_date_sup'])){
			$filter['expiry_date_sup'] = acymailing_replaceDate($filter['expiry_date_sup']);
			if(is_numeric($filter['expiry_date_sup'])) $filter['expiry_date_sup'] = date('Y-m-d H:i', $filter['expiry_date_sup']);
			$lj .= " AND (".$prefix."osemem$num.`expired_date` < ".$query->db->Quote($filter['expiry_date_sup'])." AND ".$prefix."osemem$num.`expired_date` > '1970')";
		}

		return $lj;
	}

	function onAcyProcessFilterCount_osefields(&$query, $filter, $num){
		$this->onAcyProcessFilter_osefields($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_osefields(&$query, $filter, $num){
		if(!strpos($filter['field'], '-')) return;

		$field = explode('-', $filter['field']);

		if($field[1] == 'datefield'){
			$value = acymailing_replaceDate($filter['value']);
			if(is_numeric($value)) $value = strftime('%m/%d/%Y', $value);
		}else{
			$value = $filter['value'];
		}

		$query->join['osemember'] = '#__osemsc_member AS osemember ON sub.userid = osemember.member_id';
		$query->join[] = '#__osemsc_fields_values AS osememberfields'.$num.' ON osememberfields'.$num.'.member_id = osemember.member_id';
		$query->where[] = 'osememberfields'.$num.'.field_id = '.intval($field[0]);
		$query->where[] = $query->convertQuery('osememberfields'.$num, 'value', $filter['operator'], $value);
	}

	// Change the input field to display suggestions
	function onAcyTriggerFct_displayOSEMembersValues(){
		$num = JRequest::getInt('num');
		$field = JRequest::getString('field');
		$cond = JRequest::getVar('cond', '', '', 'string', JREQUEST_ALLOWHTML);
		$value = JRequest::getString('value');

		// Default return: empty input field
		$emptyInputReturn = '<input onchange="countresults('.$num.')" class="inputbox" type="text" name="filter['.$num.'][osefields][value]" id="filter'.$num.'osefieldsvalue" style="width:200px" value="'.$value.'">';

		// Display first 100 values for some fields
		if(empty($field) || !strpos($field, '-') || !in_array($cond, array('=', '!=', 'CONTAINS', 'NOTCONTAINS', 'LIKE', 'NOT LIKE', 'REGEXP', 'NOT REGEXP'))) return $emptyInputReturn;

		$field = explode('-', $field);

		if(!in_array($field[1], array('radio', 'combo', 'multiselect'))) return $emptyInputReturn;

		$db = JFactory::getDBO();
		$query = 'SELECT params FROM #__osemsc_fields WHERE id = '.intval($field[0]);
		$db->setQuery($query);
		$prop = $db->loadResult();

		// No values -> default return
		if(empty($prop)) return $emptyInputReturn;
		$prop = explode(',', $prop);
		$propositions = array();
		foreach($prop as $oneProp){
			$tmp = new stdClass();
			$tmp->value = $oneProp;
			$propositions[] = $tmp;
		}

		return JHTML::_('select.genericlist', $propositions, "filter[$num][osefields][value]", 'onchange="countresults('.$num.')" class="inputbox" size="1" style="width:200px"', 'value', 'value', $value, 'filter'.$num.'osefieldsvalue');
	}

	function onAcyTriggerFct_displayOSEMembershipPayments(){
		$num = JRequest::getInt('num');
		$value = JRequest::getInt('value');
		$membership = intval(JRequest::getString('membership'));

		// Default return: empty input field
		$emptyInputReturn = '<input onchange="countresults('.$num.')" disabled="disabled" class="inputbox" type="text" name="filter['.$num.'][osemembership][payment]" style="width:200px" value="" id="filter'.$num.'osemembershippayment"/>';

		// Display first 100 values for some fields
		if(empty($membership)) return $emptyInputReturn;

		$db = JFactory::getDBO();
		$query = 'SELECT params FROM #__osemsc_ext WHERE type = "payment" AND id = '.$membership;
		$db->setQuery($query);
		$params = $db->loadResult();

		if(empty($params)) return $emptyInputReturn;

		$decodedParams = (array)json_decode($params);

		$propositions = array();
		$tmp = new stdClass();
		$tmp->value = 0;
		$tmp->text = '- - -';
		$propositions[] = $tmp;
		foreach($decodedParams as $i => $onePayment){
			$tmp = new stdClass();
			$tmp->value = $i;
			$tmp->text = $onePayment->optionname;
			$propositions[] = $tmp;
		}

		return JHTML::_('select.genericlist', $propositions, "filter[$num][osemembership][payment]", 'onchange="countresults('.$num.')" class="inputbox" size="1" style="width:200px"', 'value', 'text', $value, 'filter'.$num.'osemembershippayment');
	}
}//endclass